;***********************************************************
;*                 AT90S1200        
;*                     
;* CLK   32768 
;* CIKL  30  
;* 
;* 
;***********************************************************


.include "1200def.inc";      
                      ; 





; 




.DEF	D	=r10	;  

.DEF	NB	=r11	;  EEPROM   

.DEF	DS	=r12	;    

.DEF	SEL	=r14	; SELECT(  ,  ,     )

.DEF	SEL_D	=r15	;   (  )

.DEF	SS	=r17	; 

.DEF	M	=r18	;   

.DEF	MM	=r19	;   

.DEF	H	=r20	;   

.DEF	HH	=r21	;   

.DEF	TH	=r22	;   

.DEF	THH	=r23	;    

.DEF	TM	=r24	;   

.DEF	TMM	=r25	;    

.DEF	TH1	=r26	;   

.DEF	THH1	=r27	;    

.DEF	TM1	=r28	;   

.DEF	TMM1	=r29	;    

.DEF	B	=r30	;  

.DEF	A	=r31	;







.CSEG                  ;  
.ORG 0

        RJMP RESET	;  reset
        NOP		;  int
	 INC SS		;  (  TMR0)
	;NOP		;  compare
        
        





;********************************************************************
;   \ ( 1024200  .)
;********************************************************************


TMR0:	
		
	
	LDI B,224
	OUT TCNT0,B	;   32 (256-224=32)
	
	CPI SS,60	;SS=60?
	BREQ T2		;     2,  
	RETI		;  

T2:	CLR SS		; SS
	INC M		; 
	CPI M,10	;  10?
	BREQ T3		;     3,  
	RETI		;  
	
T3:	CLR M		; M
	INC MM		;  
	CPI MM,6	;   6?
	BREQ T4		;     4,  
	RETI

T4:	CLR MM		; 
	INC H		; 
	CPI H,4		;  4?
	BREQ T5		;     5,  
	CPI H,10	;  10?
	BREQ T9		;     9,  
	RETI		;  


T5: 	CPI HH,2	;   2?
	BREQ T6		;     6,  
	CPI H,10	;  10?
	BREQ T7		;     7,  
	RETI		;  

	
T6:	CLR HH		;  
	CLR H		; 
	INC D		; 
	MOV B,D
	CPI B,8		;  8?
	BREQ T8		;     	8,  
	RETI		;  

T7:	CLR H		; 
	INC HH		;  
	RETI		;  
	


T8:	LDI B,1
	MOV D,B
	RETI		;     
	

T9:	CLR H		; 
	INC HH		;   
	RETI		;  		

;____________________________________________________________________


;********************************************************************
;
;********************************************************************

RESET:	
	

	
	LDI A,0B0000101	;  / 
	OUT TCCR0,A		;   CLK/1024
	LDI A,224
	OUT TCNT0,A		;   32( 32768/1024/32=1

       	LDI A,0B00000010
	OUT TIMSK,A		;   /
       
	LDI A,0B10001111	
	OUT DDRB,A		;  B.1-,0-

	LDI A,0B01110000
	OUT PORTB,A		;     
				;    

	LDI A,0B11111111
	OUT DDRD,A		;  D  

	CBI PORTB,7		; 

	SBI ACSR,7		;  (  )	
			
	
	CLR SS			;  
	LDI M,1			;   
	CLR MM			;  
	CLR H			; 
	CLR HH			;  
	CLR TM			;    
	CLR TMM			;     
	CLR TH			;    
	CLR THH			;     
	CLR TM1			;    
	CLR TMM1		;     
	CLR TH1			;    
	CLR THH1		;     
	CLR SEL			;  SEL(  ,  )
	
	LDI A,1
	MOV D,A			;  D  (  ,  -)
	
		CLR DS			;  DS(   )
;------------------------------------------------------------------------------
;     EEPROM,   ,
;    - 0
;------------------------------------------------------------------------------

	LDI A,0
WER:
	SBIC EECR,EEWE
	RJMP WER 	;Ĩ  

	OUT EEAR,A	;   
 	OUT EEDR,DS	;   
	SBI EECR,EEWE	;  

WERR:	SBIC EECR,EEWE
	RJMP WERR 	;Ĩ   EEPROM  	
	
	INC A
	CPI A,10
	BREQ SEI
	RJMP WER	;     0
;------------------------------------------------------------

			
SEI:	SEI			; 




;____________________________________________________________________


;********************************************************************
;                       
;  ,   ,
;    .
;
;********************************************************************

MAIN:	
	
	RJMP KEY	;   
MAIN1:
	
;--------------------------------------------------------------------
;      ,
;      ,  . 
;--------------------------------------------------------------------
	CLR A
	OUT PORTD,A	; 
	CBI DDRB,0	;    0  
	CBI PORTB,0	;  0  B ( .)
	SBIS PINB,0	; .     .1
	RJMP SLEEP	;   .0(  )
			;    SLEEP

		
	SBI DDRB,0
	SBI PORTB,0	;     
			;       
			;
;___



	MOV A,SEL
	CPI A,0	;
	BREQ CLOCK	; SEL=0     
	CPI A,1	;
	BREQ ALARM	; SEL=1       
	CPI A,2	;
	BREQ ALARM1	; SEL=2       
	;CPI A,3	;
	RJMP SET_DAY	; SEL=3      
;_____________



;********************************************************************
;     
;********************************************************************

CLOCK:	MOV A,M		;   
	RCALL DECOD	; 
	CBI PORTB,3	;  
	RCALL PAUSAA	;
	
	SBI PORTB,3	;  

	MOV A,MM	;    
	RCALL DECOD	; 
	CBI PORTB,2	;   
	RCALL PAUSAA	;
	SBI PORTB,2	;   

	MOV A,H		;   
	RCALL DECOD	; 
	CBI PORTB,1	;  
	RCALL PAUSAA	;
	SBI PORTB,1	;  

	MOV A,HH	;    
	RCALL DECOD	; 
	CBI PORTB,0	;   
	RCALL PAUSAA	;
	SBI PORTB,0	;   

	RJMP ALLARM	;     
	
MAIN0:
	RJMP ALLARM1	;      


;____________________________________________________________________


;********************************************************************
;      
;********************************************************************

ALARM:	MOV A,TM	;   
	RCALL DECOD	; 
	CBI PORTB,3	;  
	RCALL PAUSAA	;
	
	SBI PORTB,3	;  

	MOV A,TMM	;    
	RCALL DECOD	; 
	CBI PORTB,2	;   
	RCALL PAUSAA	;
	SBI PORTB,2	;   

	MOV A,TH	;   
	RCALL DECOD	; 
	CBI PORTB,1	;  
	RCALL PAUSAA	;
	SBI PORTB,1	;  

	MOV A,THH	;    
	RCALL DECOD	; 
	CBI PORTB,0	;   
	RCALL PAUSAA	;
	SBI PORTB,0	;   

	RJMP MAIN
;____________________________________________________________________


;********************************************************************
;      
;********************************************************************

ALARM1:	MOV A,TM1	;   
	RCALL DECOD	; 
	CBI PORTB,3	;  
	RCALL PAUSAA	;
	
	SBI PORTB,3	;  

	MOV A,TMM1	;    
	RCALL DECOD	; 
	CBI PORTB,2	;   
	RCALL PAUSAA	;
	SBI PORTB,2	;   

	MOV A,TH1	;   
	RCALL DECOD	; 
	CBI PORTB,1	;  
	RCALL PAUSAA	;
	SBI PORTB,1	;  

	MOV A,THH1	;    
	RCALL DECOD	; 
	CBI PORTB,0	;   
	RCALL PAUSAA	;
	SBI PORTB,0	;   

	RJMP MAIN
;____________________________________________________________________


;********************************************************************
;      
;********************************************************************

SET_DAY:
	LDI A,94
	OUT PORTD,A	;     d-
	CBI PORTB,0	;  
	RCALL PAUSAA	;
	SBI PORTB,0	;  

	MOV A,D		;    
	RCALL DECOD	; 
	CBI PORTB,1	;  
	RCALL PAUSAA	;
	SBI PORTB,1	; 


	OUT EEAR,D	;
	SBI EECR,EERE	;  EEPROM    
	IN A,EEDR	;      
	
	RCALL DECOD	; 
	CBI PORTB,2	;  
	RCALL PAUSAA	;
	SBI PORTB,2	; 

	RJMP MAIN
;____________________________________________________________________
	
	
;********************************************************************
;         		
;
;   ,   .
;     A- .
;
;********************************************************************

DECOD:
	CPI A,0
	BREQ P1
	CPI A,1
	BREQ P2
	CPI A,2
	BREQ P3
	CPI A,3
	BREQ P4
	CPI A,4
	BREQ P5
	CPI A,5
	BREQ P6
	CPI A,6
	BREQ P7
	CPI A,7
	BREQ P8
	CPI A,8
	BREQ P9
	CPI A,9
	BREQ P10

P1:	LDI A,63
	RJMP QUIT
P2:	LDI A,6
	RJMP QUIT
P3:	LDI A,91
	RJMP QUIT
P4:	LDI A,79
	RJMP QUIT
P5:	LDI A,102
	RJMP QUIT
P6:	LDI A,109
	RJMP QUIT
P7:	LDI A,125
	RJMP QUIT
P8:	LDI A,7
	RJMP QUIT
P9:	LDI A,127
	RJMP QUIT
P10:	LDI A,111
	RJMP QUIT

QUIT:	
	OUT PORTD,A
	RET
;____________________________________________________________________




;********************************************************************
;   
;********************************************************************

PAUSA:
	LDI A,100
	
PAU:	DEC A
	BREQ PAUS
	RJMP PAU

PAUS:	RET
;____________________________________________________________________



;********************************************************************
;   
;********************************************************************

PAUSAA:
	LDI A,20
	
PAUU:	DEC A
	BREQ PAUSS
	RJMP PAUU

PAUSS:	RET
;____________________________________________________________________





;********************************************************************
;  
;********************************************************************

KEY:	
	TST SEL_D	; SEL_D  0
	BREQ KEY1	; SEL_D=0,     . 
			;KEY1,   KEY0.

KEY0:	SBIS PINB,4	;SELEKT ?
	RJMP MAIN1	;   
	SBIS PINB,5	;HUR ?
	RJMP MAIN1	;   
	SBIS PINB,6	;MIN ?
	RJMP MAIN1	;   

	CLR SEL_D	;   (  )
	RJMP MAIN1	;

	

KEY1:	
	
	SBIS PINB,4	;SELECT ?
	RJMP SELEKT 	;  SELECT
	SBIS PINB,5	;HUR ?
	RJMP HUR	;,  HUR
	SBIS PINB,6	;MIN ?
	RJMP MIN	;.  MIN
			
	RJMP MAIN1	;      

;____________________________________________________________________

SELEKT:
	RCALL PAUSA	;   

	SBIC PINB,4	;
	RJMP MAIN 	;       , 
	
	LDI A,1
	MOV SEL_D,A	;  SEL_D(  )
	INC SEL		; SEL
	MOV A,SEL 
	CPI A,4
	BREQ E		; SEL=4     ( )
	RJMP MAIN1	;
E:	CLR SEL		;  SEL,0
	RJMP MAIN1	;

	

;____________________________________________________________________

HUR:	
	RCALL PAUSA	;   	

     	SBIC PINB,5	;
	RJMP MAIN 	;       , 	

	LDI A,1
	MOV SEL_D,A	;  SEL_D(  
	MOV A,SEL
	CPI A,0	;
	BREQ CL_H	; SEL=0     
	MOV A,SEL
	CPI A,1	;
	BREQ AL_H	; SEL=1      .
	MOV A,SEL
	CPI A,2	;
	BREQ AL_H1	; SEL=2     .1
	RJMP DEY	; SEL=3      


;------------------------------------------
;    
;------------------------------------------
CL_H:	INC H		; 
	CPI H,4
	BREQ H		;   4    ( )
H3:	CPI H,10
	BREQ H1		;   10    1( )
	RJMP MAIN	;  MAIN
H:	CPI HH,2	
	BREQ H2		;   24    2( )
	RJMP H3
H1:	CLR H		;  
	INC HH		;  .
	CPI HH,3
	BREQ H2		;  .  3    2
	RJMP MAIN	;  MAIN
H2:	CLR H
	CLR HH
	RJMP MAIN	;      MAIN
;------------------------------------------



;-------------------------------------------------
;     
;-------------------------------------------------
AL_H:	INC TH		; 
	CPI TH,4
	BREQ TH		;   4    ( )
TH3:	CPI TH,10
	BREQ TH1	;   10    1( )
	RJMP MAIN	;  MAIN
TH:	CPI THH,2	
	BREQ TH2	;   24    2 (..)
	RJMP TH3
TH1:	CLR TH		;  
	INC THH		;  .
	CPI THH,3
	BREQ TH2	;  .  3    2
	RJMP MAIN	;  MAIN
TH2:	CLR TH
	CLR THH
	RJMP MAIN	;      MAIN
;-------------------------------------------------



	
;-------------------------------------------------
;     
;-------------------------------------------------
AL_H1:	INC TH1		; 
	CPI TH1,4
	BREQ TH4	;   4    4( )
TH7:	CPI TH1,10
	BREQ TH5	;   10    1( )
	RJMP MAIN	;  MAIN
TH4:	CPI THH1,2	
	BREQ TH6	;   24    2 (..)
	RJMP TH7
TH5:	CLR TH1		;  
	INC THH1	;  .
	CPI THH1,3
	BREQ TH6	;  .  3    2
	RJMP MAIN	;  MAIN
TH6:	CLR TH1
	CLR THH1
	RJMP MAIN	;      MAIN
;------------------------------------------------




;-------------------------------------------------
;     
;-------------------------------------------------
DEY:		
	INC D		;   
	MOV A,D
	CPI A,8
	BREQ L		;     8    L
	RJMP MAIN

L:	LDI A,1
	MOV D,A	;        ..
	RJMP MAIN
;-------------------------------------------------




;-------------------------------------------------
;    
;-------------------------------------------------
MIN:
	RCALL PAUSA	;   	

     	SBIC PINB,6	;
	RJMP MAIN 	;       , 	

	LDI A,1
	MOV SEL_D,A	;  SEL_D(  
	MOV A,SEL
	CPI A,0	;
	BREQ CL_M	; SEL=0      
	MOV A,SEL
	CPI A,1	;
	BREQ AL_M	; SEL=1     . 
	MOV A,SEL
	CPI A,2	;
	BREQ AL_M1	; SEL=2     . 1
	RJMP DEY_S	; SEL=3      


CL_M:	INC M		; 
	CLR SS		;   ( )
	CPI M,10
	BREQ J1		;   10    J1( )
	RJMP MAIN	;  MAIN

J1:	CLR M		;  
	INC MM		;  .
	CPI MM,6
	BREQ J2		;  .  6    J2
	RJMP MAIN	;  MAIN
J2:	CLR MM		;  .
	CLR M		;  
	;INC M		;  
	RJMP MAIN	;  MAIN
;----------------------------------------------------



	
;-------------------------------------------------
;     
;-------------------------------------------------
AL_M:	INC TM		; 
	
	CPI TM,10
	BREQ J3 	;   10    J3( )
	RJMP MAIN	;  MAIN

J3:	CLR TM		;  
	INC TMM		;  .
	CPI TMM,6
	BREQ J4 	;  .  6    J4
	RJMP MAIN	;  MAIN
J4:	CLR TMM		;  .
	CLR TM		;  
	RJMP MAIN	;  MAIN
;--------------------------------------------------



	
;-------------------------------------------------
;     
;-------------------------------------------------
AL_M1:	INC TM1		; 
	
	CPI TM1,10	
	BREQ J5		;   10    J5( )
	RJMP MAIN	;  MAIN

J5:	CLR TM1		;  
	INC TMM1	;  .
	CPI TMM1,6
	BREQ J6		;  .  6    J6
	RJMP MAIN	;  MAIN
J6:	CLR TMM1	;  .
	CLR TM1		;  
	RJMP MAIN	;  MAIN
;-------------------------------------------------




;---------------------------------------------------
;     
;---------------------------------------------------
DEY_S:
	
		
	INC DS		;   
	MOV A,DS
	CPI A,4
	BREQ L1		;      4    L1
	RJMP WR

L1:	LDI A,0	
	MOV DS,A	;    ..
	RJMP WR




WR:
	SBIC EECR,EEWE
	RJMP WR 	;Ĩ  

	OUT EEAR,D	;   
 	OUT EEDR,DS	;   
	SBI EECR,EEWE	;  

WRR:	SBIC EECR,EEWE
	RJMP WRR 	;Ĩ   EEPROM  	
	
	RJMP MAIN
;---------------------------------------------------



;***************************************************************************
;*     
;***************************************************************************
	
ALLARM:
	
	CP HH,THH	
	BREQ I		; .    I
	RJMP MAIN0	; 
I:	CP H,TH		
	BREQ I1 	;     I1
	RJMP MAIN0	; 
I1:	CP MM,TMM	;
	BREQ I2		; .    I2
	RJMP MAIN0	; 
I2:	CP M,TM	
	BREQ I3		;     I3
	RJMP MAIN0	; 

I3:	OUT EEAR,D	;
	SBI EECR,EERE	;  EEPROM    
	IN A,EEDR	;   
	
	CPI A,0
	BREQ I4
	CPI A,1
	BREQ I4
	CPI A,2
	BREQ I5
	CPI A,3
	BREQ I5
			;      

I4:	SBI PORTB,7	; 
	RJMP MAIN0

I5:   	CBI PORTB,7	; 
	RJMP MAIN0
;__________________________________________________________________________



;***************************************************************************
;*     
;***************************************************************************

ALLARM1:
	
	CP HH,THH1	
	BREQ II		; .    II
	RJMP MAIN	; 
II:	CP H,TH1		
	BREQ II1 	;     II1
	RJMP MAIN	; 
II1:	CP MM,TMM1	;
	BREQ II2	; .    II2
	RJMP MAIN	; 
II2:	CP M,TM1	
	BREQ II3	;     II3
	RJMP MAIN	; 

II3:	OUT EEAR,D	;
	SBI EECR,EERE	;  EEPROM    
	IN A,EEDR	;   
	
	CPI A,0
	BREQ II5
	CPI A,1
	BREQ II4
	CPI A,2
	BREQ II5
	CPI A,3
	BREQ II4
			;      

II4:	SBI PORTB,7	; 
	RJMP MAIN

II5:   	CBI PORTB,7	; 
	RJMP MAIN

;__________________________________________________________________________	


;------------------------------------------------------------------
;    ,   
;------------------------------------------------------------------

SLEEP:	LDI A,0B00100000
	OUT MCUCR,A	;( SLEEP)
	
	SLEEP		;  SLEEP
	RJMP ALLARM	;      (
			; SLEEP)
;__________________________________________________________________
	